@import "./typography";
@import "./mediaQueries";

// palette
// blue
$blue-100: rgb(207 229 255);
$blue-500: rgb(0 95 204);
$blue-600: rgb(5 80 165);
$blue-700: rgb(8 63 126);
$blue-800: rgb(9 45 87);
$blue-900: rgb(6 26 48);

// gray
$gray-100: rgb(249 250 251);
$gray-200: rgb(243 244 247);
$gray-300: rgb(231 233 238);
$gray-400: rgb(219 222 230);
$gray-500: rgb(184 190 204);
$gray-600: rgb(112 125 153);
$gray-700: rgb(84 95 120);
$gray-800: rgb(44 50 63);
$gray-900: rgb(24 27 34);
$gray-black: rgb(15 17 21);
$gray-color-100: rgb(241 245 248);
$gray-color-200: rgb(234 237 243);
$gray-color-300: rgb(206 212 218);
$gray-color-400: rgb(117 128 153);

// color-theme
$primary-color: $blue-500;
$primary-color-hover: $blue-600;
$primary-color-active: $blue-700;
$secondary-color: $gray-800;
$secondary-color-hover: $gray-900;
$secondary-color-active: $gray-black;
$tertiary-color: $gray-200;
$tertiary-color-hover: $gray-300;
$tertiary-color-active: $gray-400;
$black: $gray-black;
$white: rgb(255 255 255);
$color-success: rgb(85 154 77);
$color-warning: rgb(255 152 0);
$color-error: rgb(207 23 37);
$blue-dark-gray: rgb(34 39 50);
$color-yellow: #e8d000;

// banner
$banner-warning: rgb(207 159 81 / 15%);
$banner-warning-text: $color-warning;
$banner-error: rgb(224 119 96 / 15%);
$banner-error-text: $color-error;
$banner-info: rgb(83 149 103 / 15%);
$banner-info-text: $color-success;

// border
$border-primary: $gray-300;
$border-secondary: $gray-400;

// backgroung
$background-accent-primary: $blue-500;
$background-neutral-lite: $gray-100;
$background-neutral-normal: $gray-200;
$background-neutral-secondary: $gray-300;
$background-neutral-invert: $white;

// spacing
$spacing-1: 4px;
$spacing-2: 8px;
$spacing-3: 12px;
$spacing-4: 16px;
$spacing-5: 20px;
$spacing-6: 24px;
$spacing-7: 28px;
$spacing-8: 32px;
$spacing-9: 36px;
$spacing-10: 40px;
$spacing-11: 44px;
$spacing-12: 48px;
$spacing-13: 52px;
$spacing-14: 56px;
$spacing-15: 60px;
$spacing-16: 64px;

@mixin strokes {
    &_color-primary {
        stroke: $primary-color;
    }

    &_color-secondary {
        stroke: $secondary-color;
    }

    &_color-tertiary {
        stroke: $tertiary-color;
    }

    &_color-black {
        stroke: $black;
    }

    &_color-white {
        stroke: $white;
    }

    &_color-yellow {
        stroke: $color-yellow;
    }

    &_color-gray-middle {
        stroke: $gray-600;
    }

    &_color-gray-dark {
        stroke: $gray-700;
    }

    &_color-gray-darker {
        stroke: $gray-800;
    }

    &_color-black-gray {
        stroke: $gray-600;
    }

    &_color-error {
        stroke: $color-error;
    }
}

@mixin fills {
    &_color-primary {
        fill: $primary-color;
    }

    &_color-secondary {
        fill: $secondary-color;
    }

    &_color-tertiary {
        fill: $tertiary-color;
    }

    &_color-black {
        fill: $black;
    }

    &_color-white {
        fill: $white;
    }

    &_color-gray-middle {
        fill: $gray-600;
    }

    &_color-gray-dark {
        fill: $gray-700;
    }

    &_color-gray-darker {
        fill: $gray-800;
    }

    &_color-black-gray {
        fill: $gray-600;
    }

    &_color-error {
        fill: $color-error;
    }
}

@mixin direction($deg) {
    transform: rotate($deg);
    transform-box: fill-box;
    transform-origin: center;
}

// horizontal line
@mixin horizontal-line {
    color: $primary-color-dark;
    opacity: 0.2;
    width: 100%;
}

// shadows
$shadow-light: 0 5px 5px rgba(0 51 102 / 30%);
$shadow: rgb(0 0 0 / 25%) 0 4px 4px;

@mixin card-shadow {
    box-shadow:
        0 84px 136px rgb(0 51 102 / 8%),
        0 19px 30px rgb(0 51 102 / 4%),
        0 5px 9px rgb(0 51 102 / 5%);
}

@mixin shadow-high {
    box-shadow:
        0 100px 80px rgb(0 0 0 / 13%),
        0 41px 33px rgb(0 0 0 / 9%),
        0 22px 17px rgb(0 0 0 / 7%),
        0 12px 10px rgba(0 0 0 / 6%),
        0 6px 5px rgb(0 0 0 / 5%),
        0 2px 2px rgb(0 0 0 / 3%);
}

@mixin shadow-inset {
    box-shadow: inset 0 4px 4px rgb(0 51 102 / 10%);
}

@mixin scroll-nav-shadow {
    box-shadow:
        0 22px 48px rgb(0 0 0 / 15%),
        0 8px 18px rgb(0 0 0 / 11%),
        0 4px 9px rgb(0 0 0 / 9%),
        0 2px 4px rgb(0 0 0 / 7%),
        0 1px 2px rgb(0 0 0 / 5%);
}

@mixin shadow-focus {
    box-shadow: 0 0 0 3px rgb(38 151 255 / 100%);
}

@mixin shadow-dropdown {
    box-shadow: 0 16px 24px 0 rgb(34 39 50 / 12%);
}

@mixin shadow-header {
    box-shadow: 8px 18px 36px 0 rgb(0 0 0 / 4%);
}

// scrollbars

@mixin scrollbar-thin {
    &::-webkit-scrollbar-track {
        border: 1px solid $gray-400;
        padding: 2px 0;
        background-color: $gray-400;
    }

    &::-webkit-scrollbar {
        width: 4px;
    }

    &::-webkit-scrollbar-thumb {
        border-radius: 10px;
        box-shadow: inset 0 0 6px $black(0 0 0 / 30%);
        background-color: $gray-600;
        border: 1px solid $gray-600;
    }
}

@mixin scrollbar-thin-light {
    &::-webkit-scrollbar-track {
        border: 1px solid $gray-100;
        background-color: $gray-100;
        padding: 1rem 0;
    }

    &::-webkit-scrollbar {
        width: 4px;
    }

    &::-webkit-scrollbar-thumb {
        border-radius: 10px;
        box-shadow: inset 0 0 6px $black(0 0 0 / 30%);
        background-color: $gray-300;
        border: 1px solid $gray-300;
    }
}

// layout
$padding-sm: 1rem;
$padding-lg: 2.5rem;
$border-radius-menu: 4px 0 0 4px;
$border-radius: 8px;

@mixin json-newline {
    white-space: pre-line;
    vertical-align: bottom;
}

@mixin text-truncate {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
}

// flex
@mixin col {
    display: flex;
    flex-direction: column;
}

@mixin row {
    display: flex;
    flex-direction: row;
}

@mixin flex-center {
    display: flex;
    justify-content: center;
    align-items: center;
}

@mixin hidden-field {
    opacity: 0;
    position: absolute;
    top: 0;
    left: -666px;
    height: 0;
    width: 0;
    z-index: -1;
}

@mixin error-message {
    color: $color-error;

    @include caption-2m;
}
